<?if(!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED!==true)die();
/** @var CBitrixComponent $this */
/** @var array $arParams */
/** @var array $arResult */
/** @var string $componentPath */
/** @var string $componentName */
/** @var string $componentTemplate */
/** @global CDatabase $DB */
/** @global CUser $USER */
/** @global CMain $APPLICATION */


$arDefaultUrlTemplates404 = array(
	"catalogs" => "catalog/",
	"catalogtypes" => "#TYPES#/",
	"catalog" => "#TYPES#/#XML_ID#/",
	"catalogsection" => "#TYPES#/#XML_ID#/#SECTION_ID#/",
	"catalogdetail" => "#TYPES#/#XML_ID#/#SECTION_ID#/#ELEMENT_ID#/"
);

$arDefaultVariableAliases404 = array();

$arDefaultVariableAliases = array();

$arComponentVariables = array(
	"catalogs",
	"catalogtypes",
	"catalog",
	"catalogsection",
	"catalogdetail"
);

if($arParams["SEF_MODE"] == "Y")
{
	$arVariables = array();

	$arUrlTemplates = CComponentEngine::MakeComponentUrlTemplates($arDefaultUrlTemplates404, $arParams["SEF_URL_TEMPLATES"]);
	$arVariableAliases = CComponentEngine::MakeComponentVariableAliases($arDefaultVariableAliases404, $arParams["VARIABLE_ALIASES"]);

	$engine = new CComponentEngine($this);
	if (CModule::IncludeModule('iblock'))
	{
		$engine->addGreedyPart("#SECTION_CODE_PATH#");
		$engine->setResolveCallback(array("CIBlockFindTools", "resolveComponentEngine"));
	}
	$componentPage = $engine->guessComponentPath(
		$arParams["SEF_FOLDER"],
		$arUrlTemplates,
		$arVariables
	);

	$b404 = false;
	if(!$componentPage)
	{
		$dir = $APPLICATION->GetCurDir();
		$dirArr=explode('/', trim($dir, '/'));
		while(count($dirArr)>1){
			array_splice($dirArr, -1, 1);
			$tmpUrl=implode("/", $dirArr);

			$componentPage = $engine->guessComponentPath(
				$arParams["SEF_FOLDER"],
				$arUrlTemplates,
				$arVariables,
				'/'.$tmpUrl.'/index.php'
			);
			if($componentPage!==false){
				break;
			}
		}
		if(!$componentPage){
			foreach($arUrlTemplates as $key=>$value){
				$tmpArr=explode('/',$value);
				foreach($tmpArr as $tmpKey=>$tmpValue){
					if(!empty($tmpValue) && strpos($dir, $tmpValue)!==false){
						$componentPage=$key;
						break(2);
					}
				}
			}
		}
		if(!$componentPage){
			$componentPage = "catalogs";
		}
		$b404 = true;
	}

	if($b404 && CModule::IncludeModule('iblock'))
	{
		$folder404 = str_replace("\\", "/", $arParams["SEF_FOLDER"]);
		if ($folder404 != "/")
			$folder404 = "/".trim($folder404, "/ \t\n\r\0\x0B")."/";
		if (substr($folder404, -1) == "/")
			$folder404 .= "index.php";

		if ($folder404 != $APPLICATION->GetCurPage(true))
		{
			\Bitrix\Iblock\Component\Tools::process404(
				""
				,($arParams["SET_STATUS_404"] === "Y")
				,($arParams["SET_STATUS_404"] === "Y")
				,($arParams["SHOW_404"] === "Y")
				,$arParams["FILE_404"]
			);
		}
	}

	CComponentEngine::InitComponentVariables($componentPage, $arComponentVariables, $arVariableAliases, $arVariables);

	$arResult = array(
		"FOLDER" => $arParams["SEF_FOLDER"],
		"URL_TEMPLATES" => $arUrlTemplates,
		"VARIABLES" => $arVariables,
		"ALIASES" => $arVariableAliases,
	);
}
else
{
	
	$arVariableAliases = CComponentEngine::MakeComponentVariableAliases($arDefaultVariableAliases, $arParams["VARIABLE_ALIASES"]);
	CComponentEngine::InitComponentVariables(false, $arComponentVariables, $arVariableAliases, $arVariables);

	$componentPage = "";
	if(isset($arVariables["catalogs"]) && intval($arVariables["catalogs"]) > 0)
		$componentPage = "catalogs";
	elseif(isset($arVariables["catalogtypes"]) && strlen($arVariables["catalogtypes"]) > 0)
		$componentPage = "catalogtypes";
	elseif(isset($arVariables["catalog"]) && intval($arVariables["catalog"]) > 0)
		$componentPage = "catalog";
	elseif(isset($arVariables["catalogsection"]) && intval($arVariables["catalogsection"]) > 0)
		$componentPage = "catalogsection";
	elseif(isset($arVariables["catalogdetail"]) && intval($arVariables["catalogdetail"]) > 0)
		$componentPage = "catalogdetail";
	else
		$componentPage = "news";

	$arResult = array(
		"FOLDER" => "",
		"URL_TEMPLATES" => Array(
			"catalogs" => htmlspecialcharsbx($APPLICATION->GetCurPage()),
			"catalogtypes" => htmlspecialcharsbx($APPLICATION->GetCurPage()."?catalogtypes=y"),
			"catalog" => htmlspecialcharsbx($APPLICATION->GetCurPage()."?catalog=y"),
			"catalogsection" => htmlspecialcharsbx($APPLICATION->GetCurPage()."?catalogsection=y"),
			"catalogdetail" => htmlspecialcharsbx($APPLICATION->GetCurPage()."?catalogdetail=y")
		),
		"VARIABLES" => $arVariables,
		"ALIASES" => $arVariableAliases
	);
}

$this->IncludeComponentTemplate($componentPage);

?>